<?php

declare(strict_types=1);

namespace NetInventors\NetiNextToolKit\Migration;

use Doctrine\DBAL\Connection;
use Shopware\Core\Framework\Migration\MigrationStep;

class Migration1634557439 extends MigrationStep
{
    public function getCreationTimestamp(): int
    {
        return 1634557439;
    }

    public function update(Connection $connection): void
    {
        $sql = '
            CREATE TABLE `neti_tk_property_group_attribute` (
                `id` BINARY(16) NOT NULL,
                `property_group_id` BINARY(16),
                `display_in_listing` TINYINT(1) NULL DEFAULT \'0\',
                `created_at` DATETIME(3) NOT NULL,
                `updated_at` DATETIME(3) NULL,
                PRIMARY KEY (`id`),
                KEY `fk.neti_tk_property_group_attribute.property_group_id` (`property_group_id`),
                CONSTRAINT `fk.neti_tk_property_group_attribute.property_group_id` FOREIGN KEY (`property_group_id`) REFERENCES `property_group` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
            ) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
        ';

        $connection->executeStatement($sql);
    }

    public function updateDestructive(Connection $connection): void
    {

    }
}